--- E:\Development\Wine\dlls\ole32\clipboard.c	Fri Aug  3 22:25:48 2001
+++ E:\Source\Odin32\src\ole32\clipboard.c	Sat Jan 26 11:46:08 2002
@@ -1238,6 +1238,29 @@
     HANDLE_ERROR( CLIPBRD_E_CANT_OPEN );
 
   hData = GetClipboardData(pformatetcIn->cfFormat);
+
+#ifdef __WIN32OS2__
+{
+  //must make a copy of global handle returned by GetClipboardData; it
+  //is not valid after we call CloseClipboard
+  //Application is responsible for freeing the memory (Forte Agent does this)
+  LPVOID src;
+  LPVOID dest;
+  ULONG  size;
+  HANDLE hDest;
+
+  src = GlobalLock(hData);
+  if(src) {
+      size = GlobalSize(hData);
+      hDest = GlobalAlloc(GHND, size);
+      dest  = GlobalLock(hDest);
+      memcpy(dest, src, size);
+      GlobalUnlock(hDest);
+      GlobalUnlock(hData);
+      hData = hDest;
+  }
+}
+#endif
 
   /* 
    * Return the clipboard data in the storage medium structure
